/* Example: standard file operations, with error checking */

/* All practical programs should check file operations. */

#include <stdio.h>
#include <stdlib.h>

#define STR_SIZE 40

int main(void)
{
  FILE *pf;  /* file pointer, or stream */
  char str[STR_SIZE], name[] = "myfile.tmp";
  
  /* open a file for writing: */
  
  pf = fopen(name, "w");  /* pf is NULL if an error occurs */
  if (pf == NULL)
  {
    fprintf(stderr, "Error opening file %s for writing\n", name);
    exit(EXIT_FAILURE);
  }
  
  fputs("Hello world!\n", pf);         /* write to the file */
  fclose(pf);                          /* close the file */
  
  /* open a file for reading: */
  
  pf = fopen(name, "r");  /* pf is NULL if an error occurs */
  if (pf == NULL)
  {
    fprintf(stderr, "Error opening file %s for reading\n", name);
    exit(EXIT_FAILURE);
  }
  
  fgets(str, STR_SIZE, pf);            /* read a line */
  printf(str);                         /* print it to the screen */
  fclose(pf);                          /* close the file */

  return EXIT_SUCCESS;
}
